clc
clear
format short
%% FEATURES INPUT
T = xlsread('DATA_random.xls');
%T = xlsread('DATA_VARYnumFEATURES6')

%% PARAMETERS
npattern = 20 % number of dataset to be used in building NN
trials_per_pattern = 1000 %repetition in building NN for best performance
portion = 0.5 % percentage of training set Ex. 0.5=50%
target = 1
display_period = 500
threshold = 0.0000001


%neural network architecture
NN = [10,10,10,10]; %number = #neuron #col = #hidden layers
%Create a feedforward neural network
%net = feedforwardnet(NN);
%net.trainParam.showWindow = false;
%net.trainParam.epochs = 1000; % Number of training epochs
%net.trainParam.max_fail = net.trainParam.epochs; % Disable early stopping
%net.trainParam.lr = 0.001; % Learning rate
%net.trainParam.min_grad = 1e-21; % Minimum gradient threshold
net.trainParam.epochs = 1000; % Number of training epochs==
%net.trainParam.max_fail = net.trainParam.epochs; % Disable early stopping
net.trainParam.lr = 0.001; % Learning rate
%net.trainParam.min_grad = 1e-30; % Minimum gradient threshold
net.trainParam.mu = 0.9; % Momentum


%Stochastic Feature Augmentation : using Gaussian distribution
m_alpha = 1;
s_alpha = 0.00;
a_beta = 0;
s_beta = 0.2;


%% DATASET (READ FROM EXCEL)
%T = xlsread('DATA.xls');
features = T(:,1:end-1);
nFeatures = size(features,2);
label = T(:,end); %METAS=-1 TB=1
n = length(label);
nMETAS = find(label==-1);
nMETAS = nMETAS(end);
idxMETAS = [1:1:nMETAS];
nTB = n - nMETAS;
idxTB = [nMETAS+1:1:n];


%% STANDARDIZATION
original_wo_standardization = T; %save
meanFeatures = mean(features);
stdFeature = std(features);

%transform : z=(x-mean)/std
for i1 = 1 : 1 : nFeatures
    features(:,i1) = (features(:,i1)-meanFeatures(i1))/stdFeature(i1);
end
%check
meanFeatures = mean(features);
stdFeature = std(features);
original_w_standardization = [features label];


%

%% CLASSIFICATION NEURAL NETWORK
fprintf('CLASSIFICATION NEURAL NETWORK\n\n')

nTraining = floor(portion*n);
nTrainingMETAS = floor(nTraining/2);
nTrainingTB = nTraining-nTrainingMETAS;
nTesting = n-nTraining;

maxACCURACY_X1 = [];
% maxPRECISION_X1 = [];
% maxRECALL_X1 = [];
% maxF1_X1 = [];
% maxSPECIFICITY_X1 = [];


maxACCURACY_X2 = [];
% maxPRECISION_X2 = [];
% maxRECALL_X2 = [];
% maxF1_X2 = [];
% maxSPECIFICITY_X2 = [];

maxACCURACY_X3 = [];
% maxPRECISION_X3 = [];
% maxRECALL_X3 = [];
% maxF1_X3 = [];
% maxSPECIFICITY_X3 = [];

for pattern = 1 : 1 : npattern
    
    
    %% original dataset / training set / testing set
    
    random_indices = randperm(length(idxMETAS), nTrainingMETAS);
    randomSelection = idxMETAS(random_indices);
    idxTrainingMETAS = sort(randomSelection);
    
    random_indices = randperm(length(idxTB), nTrainingTB);
    randomSelection = idxTB(random_indices);
    idxTrainingTB = sort(randomSelection)
    
    
    idxTestingMETAS = setdiff(idxMETAS,idxTrainingMETAS);
    nTestingMETAS = length(idxTestingMETAS);
    
    idxTestingTB = setdiff(idxTB,idxTrainingTB);
    nTestingTB = length(idxTestingTB);
    
    TrainingSetX1 = [original_w_standardization(idxTrainingMETAS,:) ; original_w_standardization(idxTrainingTB,:) ];
    TestingSet = [original_w_standardization(idxTestingMETAS,:) ; original_w_standardization(idxTestingTB,:) ];
    
    
    %% NO AUGMENT
    
    % SFA (STOCHASTIC FEATURE AUGMENTATION)
    features_AUGMENT = [];
    label_AUGMENT = [];
    label = TrainingSetX1(:,end);
    for i1 = 1 : 1 : 0
        temp1 = [];
        for i2 = 1 : 1 : nFeatures
            temp2 = [];
            for i3 = 1 : 1 : nTraining
                alpha = m_alpha + (s_alpha*randn);
                %alpha = abs(alpha);
                beta = a_beta + (s_beta*randn);
                %beta = sign(TrainingSet(i3,i2))*abs(beta);
                temp2 = [temp2 ; ((alpha*TrainingSet(i3,i2)) + beta) ];
            end
            temp1 = [temp1 temp2];
            
        end
        %check
        %sign(temp1) == sign(features)
        %temp1 - features
        features_AUGMENT = [features_AUGMENT;temp1];
        label_AUGMENT = [label_AUGMENT;label];
    end
    
    
    features_AUGMENT;
    label_AUGMENT ;
    
    AUGMENT = [ features_AUGMENT label_AUGMENT ];
    
    TrainingSetX1 = [TrainingSetX1 ; AUGMENT];
    %size( TrainingSetX1 )
    
    XTrain = TrainingSetX1(:,1:end-1)';
    YTrain = TrainingSetX1(:,end)';
    
    XTest = TestingSet(:,1:end-1)';
    YTest = TestingSet(:,end)';
    
    
    accuracy = 0;
%     recall = 0;
%     precision =0;
%     F1 = 0;
%     specificity = 0;
%     avg = 0;
    for trial = 1 : 1 : trials_per_pattern
        
        clear net
        net = feedforwardnet(NN);
        net.trainParam.showWindow = false;
        
        %Train the neural network
        [net, tr] = train(net, XTrain, YTrain);
        
        
        %Test the trained neural network
        YPredict = net(XTest);
        YPredict = sign(YPredict);
        
        %Confusion matrix
        confMat = confusionmat(YTest, YPredict);
        TP = confMat(1, 1);
        TN = confMat(2, 2);
        FP = confMat(2, 1);
        FN = confMat(1, 2);
        
        %-- MAXIMIZE ACCURACY --
        %Accuracy
        acc = (TP + TN) / sum(confMat(:));
%         %Precision
%         prec = TP / (TP + FP);
%         %Recall (Sensitivity)
%         rec = TP / (TP + FN);
%         %F1-Score
%         F1 = 2 * (prec * rec) / (prec + rec);
%         %Specificity
%         spec = TN / (TN + FP);
        
        %tempavg = (acc + prec + rec + F1 + spec)/5;
        %if tempavg > avg
        if acc > accuracy
            accuracy = acc;
%             precision = prec;
%             recall = rec;
%             F1score = F1;
%             specificity = spec;
%             avg = tempavg;
            %fprintf('%d - %d AVG=%.2f ACC.=%.2f PRE.=%.2f REC.=%.2f F1.=%.2f SPEC.=%.2f\n',pattern,trial,avg,accuracy,precision,recall,F1score,specificity)
            fprintf('%d - %d ACC.=%.2f \n',pattern,trial,accuracy)
            %save NNtempX1.mat net
        end
        
        if mod(trial,display_period)==0
            fprintf('%d - %d\n',pattern,trial)
        end
        
        if acc==1
            save NNtempACC1.mat net
            break;
        end
        
    end %<< end of trial
    
    
    maxACCURACY_X1 = [maxACCURACY_X1 accuracy];
%     maxPRECISION_X1 = [maxPRECISION_X1 precision];
%     maxRECALL_X1 = [maxRECALL_X1 recall];
%     maxF1_X1 = [maxF1_X1 F1score];
%     maxSPECIFICITY_X1 = [maxSPECIFICITY_X1 specificity];
    
    average_ACCURACY = mean(maxACCURACY_X1);
%     average_PRECISION = mean(maxPRECISION_X1);
%     average_RECALL = mean(maxRECALL_X1);
%     average_F1 = mean(maxF1_X1);
%     average_SPECIFICITY = mean(maxSPECIFICITY_X1);
    
    %     aa = abs(average_ACCURACY-avg_ACCURACY);
    %     ar = abs(average_RECALL-avg_RECALL);
    %     ap = abs(average_PRECISION-avg_PRECISION);
    %     af = abs(average_F1-avg_F1);
    %     as = abs(average_SPECIFICITY-avg_SPECIFICITY);
    
    %fprintf('X1 AVERAGING over %d patterns : ACC.=%.2f PRE.=%.2f REC.=%.2f F1.=%.2f SPEC.=%.2f\n',pattern,average_ACCURACY,average_PRECISION,average_RECALL,average_F1,average_SPECIFICITY)
    %fprintf('diff=%.10f\n',(aa+ar+ap+af+as)/5)
    %fprintf('X1 AVERAGING over %d patterns : ACC.=%.2f \n',pattern,average_ACCURACY)
    
    %     if (aa<threshold & ar<threshold & ap<threshold & af<threshold & as<threshold & aa+ar+ap+af+as~=0 & pattern>20)
    %         break;
    %     end
    
    %     avg_ACCURACY = average_ACCURACY;
    %     avg_RECALL = average_RECALL;
    %     avg_PRECISION = average_PRECISION;
    %     avg_F1 = average_F1;
    %     avg_SPECIFICITY = average_SPECIFICITY;
    
%     %% AUGMENTATION X2
%     
%     % SFA (STOCHASTIC FEATURE AUGMENTATION)
%     features_AUGMENT = [];
%     label_AUGMENT = [];
%     label = TrainingSetX1(:,end);
%     for i1 = 1 : 1 : 1 %!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
%         temp1 = [];
%         for i2 = 1 : 1 : nFeatures
%             temp2 = [];
%             for i3 = 1 : 1 : nTraining
%                 alpha = m_alpha + (s_alpha*randn);
%                 %alpha = abs(alpha);
%                 beta = a_beta + (s_beta*randn);
%                 %beta = sign(TrainingSetX1(i3,i2))*abs(beta);
%                 temp2 = [temp2 ; ((alpha*TrainingSetX1(i3,i2)) + beta) ];
%             end
%             temp1 = [temp1 temp2];
%             
%         end
%         %check
%         %sign(temp1) == sign(features)
%         %temp1 - features
%         features_AUGMENT = [features_AUGMENT;temp1];
%         label_AUGMENT = [label_AUGMENT;label];
%     end
%     
%     
%     features_AUGMENT;
%     label_AUGMENT ;
%     
%     AUGMENT = [ features_AUGMENT label_AUGMENT ];
%     
%     TrainingSetX2 = [TrainingSetX1 ; AUGMENT];
%     %size( TrainingSetX2 )
%     
%     XTrain = TrainingSetX2(:,1:end-1)';
%     YTrain = TrainingSetX2(:,end)';
%     
%     XTest = TestingSet(:,1:end-1)';
%     YTest = TestingSet(:,end)';
%     
%     
%     accuracy = 0;
% %     recall = 0;
% %     precision =0;
% %     F1 = 0;
% %     specificity = 0;
% %     avg = 0;
%     for trial = 1 : 1 : trials_per_pattern
%         
%         clear net
%         net = feedforwardnet(NN);
%         net.trainParam.showWindow = false;
%         
%         %Train the neural network
%         [net, tr] = train(net, XTrain, YTrain);
%         
%         
%         %Test the trained neural network
%         YPredict = net(XTest);
%         YPredict = sign(YPredict);
%         
%         %Confusion matrix
%         confMat = confusionmat(YTest, YPredict);
%         TP = confMat(1, 1);
%         TN = confMat(2, 2);
%         FP = confMat(2, 1);
%         FN = confMat(1, 2);
%         
%         %-- MAXIMIZE ACCURACY --
%         %Accuracy
%         acc = (TP + TN) / sum(confMat(:));
% %         %Precision
% %         prec = TP / (TP + FP);
% %         %Recall (Sensitivity)
% %         rec = TP / (TP + FN);
% %         %F1-Score
% %         F1 = 2 * (prec * rec) / (prec + rec);
% %         %Specificity
% %         spec = TN / (TN + FP);
%         
%         %tempavg = (acc + prec + rec + F1 + spec)/5;
%         %if tempavg > avg
%         if acc > accuracy
%             accuracy = acc;
% %             precision = prec;
% %             recall = rec;
% %             F1score = F1;
% %             specificity = spec;
% %             avg = tempavg;
%             %fprintf('%d - %d AVG=%.2f ACC.=%.2f PRE.=%.2f REC.=%.2f F1.=%.2f SPEC.=%.2f\n',pattern,trial,avg,accuracy,precision,recall,F1score,specificity)
%             fprintf('%d - %d ACC.=%.2f\n',pattern,trial,accuracy)
%             %save NNtempX2.mat net
%         end
%         
%         if mod(trial,display_period)==0
%             fprintf('%d - %d\n',pattern,trial)
%         end
%         
%         if acc==1
%             save NNtempACC1.mat net
%             break;
%         end
%         
%     end %<< end of trial
%     
%     
%     maxACCURACY_X2 = [maxACCURACY_X2 accuracy];
% %     maxPRECISION_X2 = [maxPRECISION_X2 precision];
% %     maxRECALL_X2 = [maxRECALL_X2 recall];
% %     maxF1_X2 = [maxF1_X2 F1score];
% %     maxSPECIFICITY_X2 = [maxSPECIFICITY_X2 specificity];
%     
%     average_ACCURACY = mean(maxACCURACY_X2);
% %     average_PRECISION = mean(maxPRECISION_X2);
% %     average_RECALL = mean(maxRECALL_X2);
% %     average_F1 = mean(maxF1_X2);
% %     average_SPECIFICITY = mean(maxSPECIFICITY_X2);
%     
%     %     aa = abs(average_ACCURACY-avg_ACCURACY);
%     %     ar = abs(average_RECALL-avg_RECALL);
%     %     ap = abs(average_PRECISION-avg_PRECISION);
%     %     af = abs(average_F1-avg_F1);
%     %     as = abs(average_SPECIFICITY-avg_SPECIFICITY);
%     
%     %fprintf('X2 AVERAGING over %d patterns : ACC.=%.2f \n',pattern,average_ACCURACY)
%     
%     %     if (aa<threshold & ar<threshold & ap<threshold & af<threshold & as<threshold & aa+ar+ap+af+as~=0 & pattern>20)
%     %         break;
%     %     end
%     
%     %     avg_ACCURACY = average_ACCURACY;
%     %     avg_RECALL = average_RECALL;
%     %     avg_PRECISION = average_PRECISION;
%     %     avg_F1 = average_F1;
%     %     avg_SPECIFICITY = average_SPECIFICITY;
%     
% 
%     
%     
%     %% AUGMENTATION X3
%     
%     % SFA (STOCHASTIC FEATURE AUGMENTATION)
%     features_AUGMENT = [];
%     label_AUGMENT = [];
%     label = TrainingSetX1(:,end);
%     for i1 = 1 : 1 : 1 %!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! NOT 2 always 1
%         temp1 = [];
%         for i2 = 1 : 1 : nFeatures
%             temp2 = [];
%             for i3 = 1 : 1 : nTraining
%                 alpha = m_alpha + (s_alpha*randn);
%                 %alpha = abs(alpha);
%                 beta = a_beta + (s_beta*randn);
%                 %beta = sign(TrainingSetX1(i3,i2))*abs(beta);
%                 temp2 = [temp2 ; ((alpha*TrainingSetX1(i3,i2)) + beta) ];
%             end
%             temp1 = [temp1 temp2];
%             
%         end
%         %check
%         %sign(temp1) == sign(features)
%         %temp1 - features
%         features_AUGMENT = [features_AUGMENT;temp1];
%         label_AUGMENT = [label_AUGMENT;label];
%     end
%     
%     
%     features_AUGMENT;
%     label_AUGMENT ;
%     
%     AUGMENT = [ features_AUGMENT label_AUGMENT ];
%     
%     TrainingSetX3 = [TrainingSetX2 ; AUGMENT];
%     %size(TrainingSetX3)
%     
%     XTrain = TrainingSetX3(:,1:end-1)';
%     YTrain = TrainingSetX3(:,end)';
%     
%     XTest = TestingSet(:,1:end-1)';
%     YTest = TestingSet(:,end)';
%     
%     
%     accuracy = 0;
% %     recall = 0;
% %     precision =0;
% %     F1 = 0;
% %     specificity = 0;
% %     avg = 0;
%     for trial = 1 : 1 : trials_per_pattern
%         
%         clear net
%         net = feedforwardnet(NN);
%         net.trainParam.showWindow = false;
%         
%         %Train the neural network
%         [net, tr] = train(net, XTrain, YTrain);
%         
%         
%         %Test the trained neural network
%         YPredict = net(XTest);
%         YPredict = sign(YPredict);
%         
%         %Confusion matrix
%         confMat = confusionmat(YTest, YPredict);
%         TP = confMat(1, 1);
%         TN = confMat(2, 2);
%         FP = confMat(2, 1);
%         FN = confMat(1, 2);
%         
%         %-- MAXIMIZE ACCURACY --
%         %Accuracy
%         acc = (TP + TN) / sum(confMat(:));
% %         %Precision
% %         prec = TP / (TP + FP);
% %         %Recall (Sensitivity)
% %         rec = TP / (TP + FN);
% %         %F1-Score
% %         F1 = 2 * (prec * rec) / (prec + rec);
% %         %Specificity
% %         spec = TN / (TN + FP);
%         
% %         tempavg = (acc + prec + rec + F1 + spec)/5;
% %         if tempavg > avg
%         if acc > accuracy
%             accuracy = acc;
% %             precision = prec;
% %             recall = rec;
% %             F1score = F1;
% %             specificity = spec;
% %             avg = tempavg;
%             %fprintf('%d - %d AVG=%.2f ACC.=%.2f PRE.=%.2f REC.=%.2f F1.=%.2f SPEC.=%.2f\n',pattern,trial,avg,accuracy,precision,recall,F1score,specificity)
%             fprintf('%d - %d ACC.=%.2f\n',pattern,trial,accuracy)
%             %save NNtempX3.mat net
%         end
%         
%         if mod(trial,display_period)==0
%             fprintf('%d - %d\n',pattern,trial)
%         end
%         
%         if acc==1
%             save NNtempACC1.mat net
%             break;
%         end
%         
%     end %<< end of trial
%     
%     
%     maxACCURACY_X3 = [maxACCURACY_X3 accuracy];
% %     maxPRECISION_X3 = [maxPRECISION_X3 precision];
% %     maxRECALL_X3 = [maxRECALL_X3 recall];
% %     maxF1_X3 = [maxF1_X3 F1score];
% %     maxSPECIFICITY_X3 = [maxSPECIFICITY_X3 specificity];
%     
%     average_ACCURACY = mean(maxACCURACY_X3);
% %     average_PRECISION = mean(maxPRECISION_X3);
% %     average_RECALL = mean(maxRECALL_X3);
% %     average_F1 = mean(maxF1_X3);
% %     average_SPECIFICITY = mean(maxSPECIFICITY_X3);
%     
%     %     aa = abs(average_ACCURACY-avg_ACCURACY);
%     %     ar = abs(average_RECALL-avg_RECALL);
%     %     ap = abs(average_PRECISION-avg_PRECISION);
%     %     af = abs(average_F1-avg_F1);
%     %     as = abs(average_SPECIFICITY-avg_SPECIFICITY);
%     
%     %fprintf('X3 AVERAGING over %d patterns : ACC.=%.2f\n',pattern,average_ACCURACY)
%     %fprintf('diff=%.10f\n',(aa+ar+ap+af+as)/5)
%     
%     %     if (aa<threshold & ar<threshold & ap<threshold & af<threshold & as<threshold & aa+ar+ap+af+as~=0 & pattern>20)
%     %         break;
%     %     end
%     
%     %     avg_ACCURACY = average_ACCURACY;
%     %     avg_RECALL = average_RECALL;
%     %     avg_PRECISION = average_PRECISION;
%     %     avg_F1 = average_F1;
%     %     avg_SPECIFICITY = average_SPECIFICITY;

    final_ACC1 = maxACCURACY_X1;
    avgACC_X1 = mean(final_ACC1);
    
%     final_ACC2 = [maxACCURACY_X1 ; maxACCURACY_X2];
%     final_ACC2 = max(final_ACC2);
%     avgACC_X2 = mean(final_ACC2);
% 
%     final_ACC3 = [maxACCURACY_X1 ; maxACCURACY_X2 ; maxACCURACY_X3];
%     final_ACC3 = max(final_ACC3);
%     avgACC_X3 = mean(final_ACC3);
    
    fprintf('AVERAGING over %d pattern(s) : ACCX1.=%.2f \n',pattern,avgACC_X1)
    
    save RUN_DETAIL.mat
    
end

% average_ACCURACY = mean(maxACCURACY)
% average_RECALL = mean(maxRECALL)
% average_PRECISION = mean(maxPRECISION)
% average_F1 = mean(maxF1)
% average_SPECIFICITY = mean(maxSPECIFICITY)
%save x1_f7.mat maxACCURACY maxRECALL maxPRECISION maxF1 maxSPECIFICITY

% final_ACC2 = [maxACCURACY_X1 ; maxACCURACY_X2];
% final_ACC2 = max(final_ACC2)
% final_ACC3 = [maxACCURACY_X1 ; maxACCURACY_X2 ; maxACCURACY_X3];
% final_ACC3 = max(final_ACC3)
